const current = $('#current')[0];
const wanted = $('#wanted')[0];
const COM = 0;
const CPL = 1;
const CUR = 2;
const levels = [
    $('#common-level'),
    $('#complete-level'),
    $('#current-level'),
];

var chatSocket;
current.selectedIndex = -1;

var completes = [];

const DALI_TYPE = GET('dali_type', DALI1);

function setCommonLevels(input) {
    if (levels[COM][0] === input) {
        $(wanted).find('option').each((_, opt) => setLevel(opt.value, COM));
    } else if (levels[CPL][0] === input) {
        completes.forEach(addr => setLevel(addr, CPL));
    } else if (levels[CUR][0] === input) {
        if (current.value) {
            setLevel(current.value, CUR);
        }
    }
}

addEventListener('keydown', (e) => {
    if (e.code === 'ArrowUp' || e.code === 'ArrowRight') {
        setCurrent(1)
    } else if (e.code === 'ArrowLeft' || e.code === 'ArrowDown') {
        setCurrent(-1);
    } else if (e.code === 'Enter') {
        setAddress();
    } else return;

    e.preventDefault();
});

function setCurrent(i) {
    const last = current.value;
    current.selectedIndex =
        current.selectedIndex+i >= current.options.length ? 0 :
            current.selectedIndex+i < 0 ? current.options.length - 1 :
                current.selectedIndex + i;

    if (last !== '') setLevel(last, COM);
    setLevel(current.value, CUR);
}

function setLevel(address, level) {
    if (DALI_TYPE === DALI2 && level !== CUR) return;

    send({
        type: 'set_current',
        message: {
            command: 'set_current',
            type: DALI_TYPE,
            address: 'D' + address,
            params: [levels[level].val()]
        }
    });
}

function setAddress() {
    setLevel(current.value, CPL);
    if (current.value !== wanted.value) {
        setLevel(wanted.value, COM);
        send({
            type: 'set_address',
            message: {
                type: DALI_TYPE,
                address: 'D' + current.value,
                params: ['D' + wanted.value]
            }
        });
    }

    $(current).find('option').each((i, opt) => {
        if (opt.value === wanted.value) {
            $(opt).remove();
            return false;
        }
    });
    completes.push(wanted.value);
    wanted.options.remove(wanted.selectedIndex);
    current.selectedIndex = -1;

    if (wanted.options.length === 0) {
        console.log('Complete');
        chatSocket.close();
    }
}

$(document).ready(function () {
    chatSocket = new WebSocket('ws://' + window.location.host + '/rapida/ws/address/' + room + '/');

    chatSocket.onclose = function(e) { alert('Соединение с сервером разорвано'); };
    chatSocket.onopen = function() {
        console.log('Opened');
    };
    chatSocket.onmessage = function (e) {
        console.log(e);
    }
});

const send = (data) => {
    chatSocket.send(
        JSON.stringify(data)
    );
};

const onLevelInput = (input) => input.labels[0].textContent = input.value;

const start = (button) => {
    $(button).hide();
    $('#work-table').show();
    for (var option of wanted.options) {
        setLevel(option.value, COM);
    }
};