import can


class CanConnection:
    def __init__(self, interface):
        self.bus = can.interface.Bus(channel=interface, **dict(
            bustype='socketcan',
            # can_filters=[
            #     {
            #         "can_id": 0x3e1,
            #         "can_mask": 0x3e1,
            #     },
            #     {
            #         "can_id": 0x03f,
            #         "can_mask": 0x03f,
            #     },
            # ],
        ))

    def stop(self):
        self.bus.shutdown()

    @staticmethod
    def check_can(interface: str, timeout=3):
        message = can.Message(arbitration_id=2080, data=bytearray([1, 2, 3]), extended_id=False)
        try:
            bus = can.interface.Bus(channel=interface, **dict(bustype='socketcan'))
            bus.send(message, timeout)
        except can.CanError:
            return False
        else:
            return True
