from . import gear
from . import responses


class _ColourControlCommand(gear._StandardCommand):
    _devicetype = 8


class Activate(_ColourControlCommand):
    _cmdval = 226


class SetTemperature(_ColourControlCommand):
    _uses_dtr0 = True
    _uses_dtr1 = True
    _cmdval = 231


class StoreColourTemperatureLimit(_ColourControlCommand):
    COOLEST = 0
    WARMEST = 1
    PHYSICAL_COOLEST = 2
    PHYSICAL_WARMEST = 3
    _uses_dtr0 = True
    _uses_dtr1 = True
    _uses_dtr2 = True
    _sendtwice = True
    _cmdval = 242


class StoreGearFeaturesStatus(_ColourControlCommand):
    _uses_dtr0 = True
    _cmdval = 243


class QueryGearFeaturesStatus(_ColourControlCommand):
    _cmdval = 247
    _response = responses.FeatureStatusResponse


class QueryColorStatus(_ColourControlCommand):
    _cmdval = 248
    _response = responses.ColourStatusResponse


class QueryColorTypeFeatures(_ColourControlCommand):
    _cmdval = 248
    _response = responses.ColourTypeFeaturesResponse


class QueryColorValue(_ColourControlCommand):
    TEMPERATURE = 2
    COOLEST = 128
    PHYSICAL_COOLEST = 129
    WARMEST = 130
    PHYSICAL_WARMEST = 131
    _cmdval = 250
    _uses_dtr0 = True
    _response = gear.command.Response
