from . import gear


class FeatureStatusResponse(gear.command.BitmapResponse):
    bits = ["Automatic Activation"]


class ColourStatusResponse(gear.command.BitmapResponse):
    bits = [
        "xy-coordinate colour point out of range",
        "Colour temperature TC out of range",
        "Auto calibration running",
        "Auto calibration successful",
        "Colour type xy-coordinate active",
        "Colour type colour temperature TC active",
        "Colour type primary N active",
        "Colour type RGBWAF active"
    ]


class ColourTypeFeaturesResponse(gear.command.BitmapResponse):
    bits = ['xy-coordinate capable', 'Colour temperature TC capable']
    ranges = {(2, 4): 'Number of primaries',
              (5, 7): 'Number of RGBWAF channels'}

    @property
    def status(self):
        res = super(ColourTypeFeaturesResponse, self).status
        for r in self.ranges:
            res.append(self.ranges[r] + ' is ' + str(self._value[r[0]:r[1]]))

        return res
