from resh.protocols.can_utils.rapida.commands import Command
from resh.protocols.can_utils.rapida.responses import Response, ServiceDali
from resh.protocols.payloads import Payload
from resh.utils.tools import bytes2str


class ServicePacket(Payload):
    mark = 'service'

    @property
    def destination_str(self):
        arr = [super(ServicePacket, self).destination_str]
        if isinstance(self.command, ServiceDali):
            arr.append(self.command.channel)
        return ' '.join(str(i) for i in arr)

    @property
    def name(self):
        arr = [self.command.__class__.__name__]
        if isinstance(self.command, Command):
            arr.append(bytes2str(self.command.params, typing=str))
        elif isinstance(self.command, Response):
            arr.append(self.command.value)

        return ' '.join(str(i) for i in arr)
